RingOfPolynomialsOver< T > Class Template Reference

Ring of polynomials over another ring. More...

Inheritance diagram for RingOfPolynomialsOver< T >:

## Classes

class | InterpolationFailed

## Public Types

typedef T | CoefficientRing
typedef PolynomialOver< T > | Element
typedef Element::CoefficientType | CoefficientType
typedef Element::RandomizationParameter | RandomizationParameter
Public Types inherited from AbstractEuclideanDomain< PolynomialOver< T > >
typedef PolynomialOver< T > | Element
Public Types inherited from AbstractRing< T >
typedef T | Element
Public Types inherited from AbstractGroup< T >
typedef T | Element

## Public Member Functions

| RingOfPolynomialsOver (const CoefficientRing &ring)
Element | RandomElement (RandomNumberGenerator &rng, const RandomizationParameter &parameter)
bool | Equal (const Element &a, const Element &b) const
| Compare two elements for equality. More...
const Element & | Identity () const
| Provides the Identity element. More...
const Element & | Add (const Element &a, const Element &b) const
| Adds elements in the group. More...
Element & | Accumulate (Element &a, const Element &b) const
| TODO. More...
const Element & | Inverse (const Element &a) const
| Inverts the element in the group. More...
const Element & | Subtract (const Element &a, const Element &b) const
| Subtracts elements in the group. More...
Element & | Reduce (Element &a, const Element &b) const
| Reduces an element in the congruence class. More...
const Element & | Double (const Element &a) const
| Doubles an element in the group. More...
const Element & | MultiplicativeIdentity () const
| Retrieves the multiplicative identity. More...
const Element & | Multiply (const Element &a, const Element &b) const
| Multiplies elements in the group. More...
const Element & | Square (const Element &a) const
| Square an element in the group. More...
bool | IsUnit (const Element &a) const
| Determines whether an element is a unit in the group. More...
const Element & | MultiplicativeInverse (const Element &a) const
| Calculate the multiplicative inverse of an element in the group. More...
const Element & | Divide (const Element &a, const Element &b) const
| Divides elements in the group. More...
const Element & | Mod (const Element &a, const Element &b) const
| Performs a modular reduction in the ring. More...
void | DivisionAlgorithm (Element &r, Element &q, const Element &a, const Element &d) const
| Performs the division algorithm on two elements in the ring. More...
Element | Interpolate (const CoefficientType x[], const CoefficientType y[], unsigned int n) const
CoefficientType | InterpolateAt (const CoefficientType &position, const CoefficientType x[], const CoefficientType y[], unsigned int n) const
Public Member Functions inherited from AbstractEuclideanDomain< PolynomialOver< T > >
virtual const Element & | Gcd (const Element &a, const Element &b) const
| Calculates the greatest common denominator in the ring. More...
Public Member Functions inherited from AbstractRing< T >
| AbstractRing ()
| Construct an AbstractRing.
| AbstractRing (const AbstractRing &source)
| Copy construct an AbstractRing. More...
AbstractRing & | operator= (const AbstractRing &source)
| Assign an AbstractRing. More...
virtual Element | Exponentiate (const Element &a, const Integer &e) const
| Raises a base to an exponent in the group. More...
virtual Element | CascadeExponentiate (const Element &x, const Integer &e1, const Element &y, const Integer &e2) const
| TODO. More...
virtual void | SimultaneousExponentiate (Element *results, const Element &base, const Integer *exponents, unsigned int exponentsCount) const
| Exponentiates a base to multiple exponents in the Ring. More...
virtual const AbstractGroup< T > & | MultiplicativeGroup () const
| Retrieves the multiplicative group. More...
Public Member Functions inherited from AbstractGroup< T >
virtual bool | InversionIsFast () const
| Determine if inversion is fast. More...
virtual Element | ScalarMultiply (const Element &a, const Integer &e) const
| Performs a scalar multiplication. More...
virtual Element | CascadeScalarMultiply (const Element &x, const Integer &e1, const Element &y, const Integer &e2) const
| TODO. More...
virtual void | SimultaneousMultiply (Element *results, const Element &base, const Integer *exponents, unsigned int exponentsCount) const
| Multiplies a base to multiple exponents in a group. More...

## Detailed Description

### template<class T>
class RingOfPolynomialsOver< T >

Ring of polynomials over another ring.

Definition at line 314 of file polynomi.h.

## Member Function Documentation

## Equal()

template<class T >

bool RingOfPolynomialsOver< T >::Equal | ( | const Element & | a,
|  | const Element & | b
| ) |  | const

inline virtual

Compare two elements for equality.

Parameters

  a | first element
  b | second element

Returns
  true if the elements are equal, false otherwise

Equal() tests the elements for equality using `a==b`

Implements AbstractGroup< T >.

Definition at line 327 of file polynomi.h.

## Identity()

template<class T >

const Element& RingOfPolynomialsOver< T >::Identity | ( |  | ) | const

inline virtual

Provides the Identity element.

Returns
  the Identity element

Implements AbstractGroup< T >.

Definition at line 330 of file polynomi.h.

## Add()

template<class T >

const Element& RingOfPolynomialsOver< T >::Add | ( | const Element & | a,
|  | const Element & | b
| ) |  | const

inline virtual

Adds elements in the group.

Parameters

  a | first element
  b | second element

Returns
  the sum of `a` and `b`

Implements AbstractGroup< T >.

Definition at line 333 of file polynomi.h.

## Accumulate()

template<class T >

Element& RingOfPolynomialsOver< T >::Accumulate | ( | Element & | a,
|  | const Element & | b
| ) |  | const

inline virtual

TODO.

Parameters

  a | first element
  b | second element

Returns
  TODO

Reimplemented from AbstractGroup< T >.

Definition at line 336 of file polynomi.h.

## Inverse()

template<class T >

const Element& RingOfPolynomialsOver< T >::Inverse | ( | const Element & | a | ) | const

inline virtual

Inverts the element in the group.

Parameters

  a | first element

Returns
  the inverse of the element

Implements AbstractGroup< T >.

Definition at line 339 of file polynomi.h.

## Subtract()

template<class T >

const Element& RingOfPolynomialsOver< T >::Subtract | ( | const Element & | a,
|  | const Element & | b
| ) |  | const

inline virtual

Subtracts elements in the group.

Parameters

  a | first element
  b | second element

Returns
  the difference of `a` and `b`. The element `a` must provide a Subtract member function.

Reimplemented from AbstractGroup< T >.

Definition at line 342 of file polynomi.h.

## Reduce()

template<class T >

Element& RingOfPolynomialsOver< T >::Reduce | ( | Element & | a,
|  | const Element & | b
| ) |  | const

inline virtual

Reduces an element in the congruence class.

Parameters

  a | element to reduce
  b | the congruence class

Returns
  the reduced element

Reimplemented from AbstractGroup< T >.

Definition at line 345 of file polynomi.h.

## Double()

template<class T >

const Element& RingOfPolynomialsOver< T >::Double | ( | const Element & | a | ) | const

inline virtual

Doubles an element in the group.

Parameters

  a | the element

Returns
  the element doubled

Reimplemented from AbstractGroup< T >.

Definition at line 348 of file polynomi.h.

## MultiplicativeIdentity()

template<class T >

const Element& RingOfPolynomialsOver< T >::MultiplicativeIdentity | ( |  | ) | const

inline virtual

Retrieves the multiplicative identity.

Returns
  the multiplicative identity

Implements AbstractRing< T >.

Definition at line 351 of file polynomi.h.

## Multiply()

template<class T >

const Element& RingOfPolynomialsOver< T >::Multiply | ( | const Element & | a,
|  | const Element & | b
| ) |  | const

inline virtual

Multiplies elements in the group.

Parameters

  a | the multiplicand
  b | the multiplier

Returns
  the product of a and b

Implements AbstractRing< T >.

Definition at line 354 of file polynomi.h.

## Square()

template<class T >

const Element& RingOfPolynomialsOver< T >::Square | ( | const Element & | a | ) | const

inline virtual

Square an element in the group.

Parameters

  a | the element

Returns
  the element squared

Reimplemented from AbstractRing< T >.

Definition at line 357 of file polynomi.h.

## IsUnit()

template<class T >

bool RingOfPolynomialsOver< T >::IsUnit | ( | const Element & | a | ) | const

inline virtual

Determines whether an element is a unit in the group.

Parameters

  a | the element

Returns
  true if the element is a unit after reduction, false otherwise.

Implements AbstractRing< T >.

Definition at line 360 of file polynomi.h.

## MultiplicativeInverse()

template<class T >

const Element& RingOfPolynomialsOver< T >::MultiplicativeInverse | ( | const Element & | a | ) | const

inline virtual

Calculate the multiplicative inverse of an element in the group.

Parameters

  a | the element

Implements AbstractRing< T >.

Definition at line 363 of file polynomi.h.

## Divide()

template<class T >

const Element& RingOfPolynomialsOver< T >::Divide | ( | const Element & | a,
|  | const Element & | b
| ) |  | const

inline virtual

Divides elements in the group.

Parameters

  a | the dividend
  b | the divisor

Returns
  the quotient

Reimplemented from AbstractRing< T >.

Definition at line 366 of file polynomi.h.

## Mod()

template<class T >

const Element& RingOfPolynomialsOver< T >::Mod | ( | const Element & | a,
|  | const Element & | b
| ) |  | const

inline virtual

Performs a modular reduction in the ring.

Parameters

  a | the element
  b | the modulus

Returns
  the result of `ab`.

Implements AbstractEuclideanDomain< PolynomialOver< T > >.

Definition at line 369 of file polynomi.h.

## DivisionAlgorithm()

template<class T >

void RingOfPolynomialsOver< T >::DivisionAlgorithm | ( | Element & | r,
|  | Element & | q,
|  | const Element & | a,
|  | const Element & | d
| ) |  | const

inline virtual

Performs the division algorithm on two elements in the ring.

Parameters

  r | the remainder
  q | the quotient
  a | the dividend
  d | the divisor

Implements AbstractEuclideanDomain< PolynomialOver< T > >.

Definition at line 372 of file polynomi.h.

The documentation for this class was generated from the following files:

- polynomi.h
- polynomi.cpp